--
-- (C) 2019-24 - ntop.org
--

-- ##############################################

local flow_alert_keys = require "flow_alert_keys"
-- Import the classes library.
local classes = require "classes"
-- Make sure to import the Superclass!
local alert = require "alert"
-- Import Mitre Att&ck utils
local mitre = require "mitre_utils"

-- ##############################################

local alert_ndpi_possible_exploit = classes.class(alert)

-- ##############################################

alert_ndpi_possible_exploit.meta = {
   alert_key  = flow_alert_keys.flow_alert_ndpi_possible_exploit,
   i18n_title = "flow_risk.ndpi_possible_exploit",
   icon = "fas fa-fw fa-exclamation",

   -- Mitre Att&ck Matrix values
   mitre_values = {
      mitre_tactic = mitre.tactic.initial_access,
      mitre_technique = mitre.technique.exploit_pub_facing_app,
      mitre_id = "T1190"
   },
}

-- ##############################################

-- @brief Prepare an alert table used to generate the alert
-- @return A table with the alert built
function alert_ndpi_possible_exploit:init()
   -- Call the parent constructor
   self.super:init()
end

-- #######################################################

function alert_ndpi_possible_exploit.format(ifid, alert, alert_type_params)
   return i18n("flow_risk.ndpi_possible_exploit_alert_descr")
end

-- #######################################################

return alert_ndpi_possible_exploit
